#include <iostream>
#include <cstdlib>
#include "Time.h"

using namespace std;

// Time class implementation

// Constructors
Time::Time()
{
  // Nothing to do

  //  cout << "Dummy/default constructor called for object at address " << this << endl;
}

// Constructors
Time::~Time()
{
  // Nothing to do

  //  cout << "Destructor called for object at address " << this << endl;
}



Time::Time(int h, int m, int s)
{
  // Assign values, but check for input errors

  //  cout << "3 parameter constructor called for object at address " << this << endl;

	if ( (h < 0) || (h > 23) ) {
		cout << "Hours value " << h << " is out of the range [0,23].\n";
		exit (0);
	}
	else {
		hour = h;
	}

	if ( (m < 0) || (m > 59) ) {
		cout << "Minutes value " << m << " is out of the range [0,59].\n";
		exit (0);
	}
	else {
		minute = m;
	}
     
	if ( (s < 0) || (s > 59) ) {
		cout << "Seconds value " << s << " is out of the range [0,59].\n";
		exit (0);
	}
	else {
		second = s;
	}
}


void Time::settime(int h, int m, int s)
{
  hour = h;
  minute = m;
  second = s;
}

// Operator overload functions
Time Time::operator+(Time t)
{
	// Calculate the total seconds in each object,
	// add them up, then convert back
	int TotalTime;
	Time sum;

	// cout << "Object sum is at address " << &sum << endl;
	// cout << "Object t is at address " << &t << endl;

	TotalTime = second + 60*minute + 3600*hour;
	TotalTime += t.second + 60*t.minute + 3600*t.hour;

	// Division here is integer division
	sum.hour = TotalTime/3600;
	sum.minute = (TotalTime - 3600*sum.hour)/60;
	sum.second = TotalTime%60;
    
	return (sum);
}

Time Time::operator-(Time t)
{
	// Calculate the total seconds in each object,
	// subtract, then convert back
	int TotalTime;
	Time sum;

	TotalTime = second + 60*minute + 3600*hour;
	TotalTime -= t.second + 60*t.minute + 3600*t.hour;

	// Division here is integer division
	sum.hour = TotalTime/3600;
	sum.minute = (TotalTime - 3600*sum.hour)/60;
	sum.second = TotalTime%60;
   
	return (sum);
}

// Other functions
void Time::AddtoTime(int h, int m, int s)
{
	// Add to values
	Time temp(h,m,s);
	(*this) = (*this) + temp;
}

void Time::Print()
{
	cout << "(" << hour << ", " << minute << ", " << second << ")\n";
}




